# SourcePath: eglibc-2.16/20160617
Summary: Embedded Glibc.
Name: sony-target-dev-eglibc-libpthread_ptt
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-eglibc-libpthread_ptt
Version: 2.16
Release: 11000006
License: LGPL2.1 / Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL: http://www.eglibc.org/home
Source0: eglibc-%{version}.tar.bz2
Source1: eglibc-ports-%{version}.tar.bz2

## LOT script Files
Source10: sony-devel-libopt-build-libc
Source11: sony-devel-libopt-build-libcrypt
Source12: sony-devel-libopt-build-libdl
Source13: sony-devel-libopt-build-libm
Source14: sony-devel-libopt-build-libpthread
Source15: sony-devel-libopt-build-librt

Patch101: 0001-Add-ARM-specific-static-stubs.c.patch
Patch102: 0001-Avoid-use-of-libgcc_s-and-libgcc_eh-when-building-gl-refreshed.patch
Patch103: 0001-R_ARM_TLS_DTPOFF32.patch
Patch104: eglibc-2.16-fix-ldso-leak-BZ15859.patch

# Add PTT support.
Patch200: eglibc-2.16-ptt.patch
Patch201: eglibc-2.16-ptt-arm.patch
Patch202: eglibc-2.16-ptt-fix-sem-post-out.patch
Patch203: eglibc-2.16-ptt-sigqueue.patch
Patch204: eglibc-2.16-CVE-2013-0242.patch
Patch205: eglibc-2.16-CVE-2013-1914.patch
Patch206: eglibc-2.16-CVE-2013-4332.patch
Patch207: eglibc-2.16-CVE-2012-4412-4424.patch
Patch208: eglibc-2.16-CVE-2013-4458.patch
Patch209: eglibc-2.16-CVE-2014-6040.patch
Patch210: eglibc-2.16-CVE-2013-2207.patch
Patch211: eglibc-2.16-CVE-2014-4043.patch
Patch212: eglibc-2.16-CVE-2014-5119.patch
Patch213: eglibc-2.16-CVE-2014-0475.patch
Patch214: eglibc-2.16-CVE-2014-7817.patch
Patch215: eglibc-2.16-CVE-2014-9402.patch
Patch216: eglibc-2.16-CVE-2015-0235.patch
Patch217: eglibc-2.16-CVE-2013-7423.patch
Patch218: eglibc-2.16-CVE-2014-8121-1.patch
Patch219: eglibc-2.16-CVE-2014-8121-2.patch
Patch220: eglibc-2.16-CVE-2014-9761-1.patch
Patch221: eglibc-2.16-CVE-2014-9761-2.patch
Patch222:  eglibc-2.16-CVE-2015-1781.patch
Patch223: eglibc-2.16-CVE-2015-1472-1473.patch
Patch224: eglibc-2.16-CVE-2015-8776.patch
Patch225: eglibc-2.16-CVE-2015-8778.patch
Patch226: eglibc-2.16-CVE-2015-8779.patch
Patch227: eglibc-2.16-submitted-resolv-first-query-failure.patch
Patch228: eglibc-2.16-CVE-2015-7547-pre1.patch
Patch229: eglibc-2.16-CVE-2015-7547-pre2.patch
Patch230: eglibc-2.16-CVE-2015-7547.patch
Patch231: eglibc-2.16-CVE-2016-1234-1.patch
Patch232: eglibc-2.16-CVE-2016-1234-2.patch
Patch233: eglibc-2.16-CVE-2016-3075.patch
Patch234: eglibc-2.16-CVE-2016-2856.patch
Patch235: eglibc-2.16-CVE-2016-4429.patch

BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_target_dir}

BuildRequires: %{sony_tool_triplet}-cross-libopt-for-dev

%description
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%package -n %{pkgname}
Summary: The GNU C Library.
Group: %{sony_group}
AutoReqProv: no


%description -n %{pkgname}
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%prep
%setup -q -n eglibc-%{version} -q -a 1

# Apply patches
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1

%patch200 -p1
%if %{sony_target_cpu} == "arm"
%patch201 -p1
%endif
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p1
%patch206 -p1
%patch207 -p1
%patch208 -p1
%patch209 -p1
%patch210 -p1
%patch211 -p1
%patch212 -p1
%patch213 -p1
%patch214 -p1
%patch215 -p1
%patch216 -p1
%patch217 -p1
%patch218 -p1
%patch219 -p1
%patch220 -p1
%patch221 -p1
%patch222 -p1
%patch223 -p1
%patch224 -p1
%patch225 -p1
%patch226 -p1
%patch227 -p1
%patch228 -p1
%patch229 -p1
%patch230 -p1
%patch231 -p1
%patch232 -p1
%patch233 -p1
%patch234 -p1
%patch235 -p1

#
# NOTE: Build with nptl, with TLS
#
%build
%sony_target_dev_setup

%define _header_dir %{sony_target_dir}%{sony_target_dev_include_dir}

export CFLAGS="-O2 -g"

# autoconf cause "checking for grep that handles long lines and -e"
# failure, config.log msg: error: no acceptable grep could be found
#autoconf &&
%if "%{sony_target_cpu}" == "ppc"
   export libc_cv_ppc_machine=yes \
	  libc_cv_ppc_rel16=no \
%endif
# to build nptl
export libc_cv_forced_unwind=yes
export libc_cv_c_cleanup=yes
export libc_cv_gnu99_inline=yes

# build libpthread library for PTT.
export BUILD_CC="gcc"
%sony_target_dev_configure \
	--disable-sanity-checks \
	--enable-add-ons=eglibc-ports-2.16,nptl \
	--enable-kernel=3.4.0 \
	--enable-profile \
	--without-cvs \
%if "%{sony_target_fpu}" == "no"
	--without-fp \
%endif
	--with-tls \
	--with-__thread \
	--without-gd \
        --with-ptt \
	--with-headers=%{_header_dir} &&
cat <<EOF > configparms &&
slibdir=%{sony_target_dev_dir}/lib
sysconfdir=%{sony_target_dev_dir}/etc
EOF
make OBJDUMP_FOR_HOST=%{sony_target_toolprefix}objdump all

mv nptl/{libpthread.so,libpthread_ptt-%{version}.so}

%install
%sony_target_dev_setup

rm -rf %{buildroot}
%define _libdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}

mkdir -p %{_libdir}
cd %{sony_objdir}
install -m 755 nptl/libpthread_ptt-%{version}.so  %{_libdir}
(cd %{_libdir} ; ln -s libpthread_ptt-%{version}.so libpthread_ptt.so.0)

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root)

%{sony_target_dir}%{sony_target_devtool_lib_dir}/libpthread_ptt.so.0
%{sony_target_dir}%{sony_target_devtool_lib_dir}/libpthread_ptt-%{version}.so

%changelog
* Mon Jun 20 2016 Sony Corporation
- Added CVE-2015-7547 and depended patches
- Added CVE-2013-7423, CVE-2014-8121, CVE-2014-9761, CVE-2015-1472, CVE-2015-1473, CVE-2015-1781,
  CVE-2015-8776, CVE-2015-8778, CVE-2015-8779, CVE-2015-0235, CVE-2016-1234, CVE-2016-3075, CVE-2016-2856, CVE-2016-4429

* Wed Jun 08 2016 Sony Corporation
- Refereshed CVE-2012-4412, CVE-2013-2207, CVE-2014-0475 fix patches

* Thu Jan 22 2015 Sony Corporation
- Added CVE-2014-7817 and CVE-2014-9402 fix patches

* Mon Sep 22 2014 Sony Corporation
- Added CVE-2013-0242,CVE-2013-1914,CVE-2013-4332,CVE-2012-4412,
  CVE-2013-4458,CVE-2013-2207,CVE-2014-0475,CVE-2014-5119,
  CVE-2014-6040 and CVE-2014-4043 fix patches

* Tue Oct 08 2013 Sony Corporation
- Added ld.so memory leak fix patch

* Mon Apr 15 2013 Sony Corporation
- Initial Build.
